local L = LibStub("AceLocale-3.0"):GetLocale("NeedjaTracker", true)

NTReports = {}

function NTReports:New(parent)
    local ret = CloneTable(NTReports)
    ret.parent = parent
    if ret.Initialize then
        ret:Initialize()
    end
    return ret
end

function NTReports:EventChoseNeed(item, player)
    PrintToChat((L.msg_roll_need):format(item, player, L["roll_" .. choice]))
end

function NTReports:EventWon(item, player, choice, roll)
    if player == UnitName("player") then
        PrintToChat((L.msg_win_you):format(
            item, L["roll_" .. choice], roll
        ))
    elseif choice == "need" then
        PrintToChat((L.msg_win_party_need):format(
            item, player, L["roll_" .. choice], roll
        ))
    else
        PrintToChat((L.msg_win_party):format(
            item, player, L["roll_" .. choice], roll
        ))
    end
end

function NTReports:EventAllPassed(item)
    PrintToChat((L.msg_pass_party):format(item))
end

function NTReports:ShowRollStatistics(channel)
    local stat = self.parent.watcher:GetRollStatistics()

    if # stat == 0 then
        PrintToChat(L.msg_stat_head_empty, channel)
        return
    end

    PrintToChat(L.msg_stat_head, channel)

    table.sort(stat, function(a, b) return a.need > b.need end)
    local top = stat[1].need
    table.sort(stat, function(a, b) return a.win > b.win end)

    local n, data
    for n, data in pairs(stat) do
        if top > 0 and data.need == top then
            PrintToChat((L.msg_stat_top):format(
                n, data.player, data.win, data.need, data.greed,
                data.disenchant, data.pass
            ), channel)
        elseif data.need > 0 then
            PrintToChat((L.msg_stat_needja):format(
                n, data.player, data.win, data.need, data.greed,
                data.disenchant, data.pass
            ), channel)
        else
            PrintToChat((L.msg_stat_line):format(
                n, data.player, data.win, data.need, data.greed,
                data.disenchant, data.pass
            ), channel)
        end
    end
end

function NTReports:ShowRollHistory(channel, full)
    local hist = self.parent.watcher:GetRollHistory()

    if # hist == 0 then
        PrintToChat(L.msg_hist_head_empty, channel)
        return
    end

    PrintToChat(L.msg_hist_head, channel)

    local n, data
    for n, data in pairs(hist) do
        if data.choice == "pass" then
            PrintToChat((L.msg_hist_pass):format(n, data.item), channel)

        elseif data.choice == "need" then
            PrintToChat((L.msg_hist_need):format(
                n, data.item, data.player, L["roll_" .. data.choice], data.roll
            ), channel)
        else
            PrintToChat((L.msg_hist_win):format(
                n, data.item, data.player, L["roll_" .. data.choice], data.roll
            ), channel)
        end
        if not full and n >= 10 then break end
    end
end
